/*
 ==============================================================================
      Module Name : MulSock.c
      Language    : SH-C Ver 4.1
      Function    : }`RlNVΉ\PbgT[o
      Note        :
        {vÓuBLC-100 BIOSt@Xv̓YtFDp
        TvvOłB
        ڑ\Pbg̎Mf[^RS-232C֑M܂B
        RS-232C̎Mf[^͑SĂ̐ڑ\Pbg֑M܂B

    
 ==============================================================================
*/
#include	<stdio.h>
#include	<string.h>

#include	"BiosIf.h"

#define	OK		1
#define	NG		-1

#define	VER		(char)1
#define	REV		(char)1

void	main(int);

/*****  vOwb_  ****************************************************/
/*     X^bN̑傫́A                                                  */
/*       (Dir.size - (vOR[h̑ + ϐ̑oCg)) / 4    */
/*     ɂȂ܂B                                                          */
static	const	struct	{
	char	Name[13];
	char	dmy;
	char	Ver;
	char	Rev;
	int		size;
	void	(*func)(int);
} Dir = {"MultiSockSv", (char)0, VER, REV, 65536, main};

int				spid;					/* VÃvZXID */

char			rdata[4096];			/* f[^obt@       */


int				ListenSockid;			/* bX\Pbg     */
int				Sockid[40];				/* ڑ\Pbg         */
unsigned char	Sockev[40];

int				SockCnt;				/* ڑ\Pbg̐     */

/*
 ------------------------------------------------------------------------------
      Routine Name : init
      Function     : 
      Result       : None
      Argument     :
       type        name          i/o  description
       ----------  ------------  ---  ------------------------------------
       int         aPid           i   vZXID
 ------------------------------------------------------------------------------
*/
void init(int aPid)
{
	int	i;								/* [vJE^      */
	int	SysPLan[16];					/* LANp[^擾 */
	int	SysPRs[3];						/* RSp[^擾  */

	/*   BIOS̏   */
	B_Init(aPid);

	/*** RS I[v ***/
	GetParam(SysPRs, 1);
	RsOpen(SysPRs);

	/*** LANI[v ***/
	GetParam(SysPLan, 0);				/* VXep[^̎擾 */
	LanOpen();

	/*** \Pbgϐ̏ ***/
	SockCnt = 0;
	for(i = 0;i < 40; i++) {
		Sockid[i] = 0;
		Sockev[i] = (unsigned char)0;
	}

	/*   TCP\Pbg쐬   */
	ListenSockid = Socket(0);

	/*** IPA|[gԍŃbX ***/
	Bind(ListenSockid,
		 (unsigned long)SysPLan[0], (unsigned short)(SysPLan[1] >> 16));
	Listen(ListenSockid, 15);
}

/*
 ------------------------------------------------------------------------------
      Routine Name : main
      Function     : C[`
      Result       : None
      Argument     :
       type        name          i/o  description
       ----------  ------------  ---  ------------------------------------
       int         aPid           i   vZXID
 ------------------------------------------------------------------------------
*/
void main(int aPid)
{
	int				i;					/* [vJE^       */
	int				len;				/* Mf[^TCY     */
	int				ret;				/* ^[R[h       */
	unsigned long	ip;					/* ڑIPAhX     */
	unsigned short	port;				/* ڑ|[gԍ     */
	int				sockmax;			/* \Pbgԍ̍ől */
	TMsg			msg;				/* bZ[W擾ϐ   */

	init(aPid);

/**************************************************************/
	while(1) {
		GetMsg((int *)&msg);
		if(msg.cmd != MSG_SYSMSG)
			/*** ƗvOȂ̂ MSG_SYSMSG ȊO͖ ***/
			continue;

		/*** RS̎Mf[^͐ڑ\PbgɑM ***/
		len = 0;
		RsGetBuff(&len, (int *)NULL, (int *)NULL, (int *)NULL);
		if(len > 0) {
			RsRecv(rdata, &len);
			for(i = 0; i < 40; i++) {
				if(Sockid[i] != 0) {
					Send(Sockid[i], rdata, len);
				}
			}
			continue;
		}

		/*** \Pbgɑ΂CxgȂΉȂ ***/
		memset((void *)Sockev, 0, sizeof(Sockev));
		sockmax = 0;
		if(ListenSockid > 0) {
			Sockev[ListenSockid-1] = (unsigned char)1;
			sockmax = ListenSockid;
		}
		for(i = 0; i < 40; i++)
			if(Sockid[i] != 0) {
				Sockev[Sockid[i]-1] = (unsigned char)1;
				if(sockmax < Sockid[i])
					sockmax = Sockid[i];
			}
		if(Select(sockmax, Sockev) <= 0)
			continue;

		/*** bX\PbgɃCxgANZvg ***/
		if((ListenSockid > 0) && (Sockev[ListenSockid-1] == 1)) {
			if((ret = Accept(ListenSockid, &ip, &port)) > 0) {
				Sockid[ret-1] = ret;
				sprintf(rdata, "Accepted(%d)\r\n", ret);
				RsSend(rdata, (int)strlen(rdata));
				SockCnt++;
				Send(Sockid[ret-1], "Accepted.\r\n", 11);
			}
		}

		/*** Mf[^VA֑M ***/
		for(i = 0; i < 40; i++) {
			if(Sockid[i] == 0)
				continue;
			if(Sockev[i] == 0)
				continue;
			len = Recv(Sockid[i], rdata, (int)sizeof(rdata));
			if(len <= 0) {
				if(Close(Sockid[i]) == OK) {
					sprintf(rdata, "Closed(%d)\r\n", Sockid[i]);
					RsSend(rdata, (int)strlen(rdata));
					Sockid[i] = 0;
					SockCnt--;
				}
			} else {
				int	j, sent;

				for(j = len; j > 0; ) {
					sent = RsSend(&rdata[len-j], j);
					if(sent > 0) {
						j -= sent;
					}
				}
			}
		}
	}
}
